/* Copyright Notice
 * bs-darkmode v2.0.0
 * https://palcarazm.github.io/bs-darkmode
 * @author 2022 Pablo Alcaraz Martínez (https://github.com/palcarazm)
 * @funding GitHub Sponsors
 * @see https://github.com/sponsors/palcarazm
 * @license MIT
 * @see https://github.com/palcarazm/bs-darkmode/blob/master/LICENSE
 */

"use strict";!function(){class i{DARKMODE_CLASS="bs-darkmode-dark";LIGHTMODE_CLASS="bs-darkmode-light";COOKIE_NAME="bs-darkmode-color-scheme";constructor(t,e){const o=!0,i=":root",s=!1,r='<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-brightness-high-fill" viewBox="0 0 16 16"><path d="M12 8a4 4 0 1 1-8 0 4 4 0 0 1 8 0zM8 0a.5.5 0 0 1 .5.5v2a.5.5 0 0 1-1 0v-2A.5.5 0 0 1 8 0zm0 13a.5.5 0 0 1 .5.5v2a.5.5 0 0 1-1 0v-2A.5.5 0 0 1 8 13zm8-5a.5.5 0 0 1-.5.5h-2a.5.5 0 0 1 0-1h2a.5.5 0 0 1 .5.5zM3 8a.5.5 0 0 1-.5.5h-2a.5.5 0 0 1 0-1h2A.5.5 0 0 1 3 8zm10.657-5.657a.5.5 0 0 1 0 .707l-1.414 1.415a.5.5 0 1 1-.707-.708l1.414-1.414a.5.5 0 0 1 .707 0zm-9.193 9.193a.5.5 0 0 1 0 .707L3.05 13.657a.5.5 0 0 1-.707-.707l1.414-1.414a.5.5 0 0 1 .707 0zm9.193 2.121a.5.5 0 0 1-.707 0l-1.414-1.414a.5.5 0 0 1 .707-.707l1.414 1.414a.5.5 0 0 1 0 .707zM4.464 4.465a.5.5 0 0 1-.707 0L2.343 3.05a.5.5 0 1 1 .707-.707l1.414 1.414a.5.5 0 0 1 0 .708z"/></svg>',a='<svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-moon-fill" viewBox="0 0 16 16"><path d="M6 .278a.768.768 0 0 1 .08.858 7.208 7.208 0 0 0-.878 3.46c0 4.021 3.278 7.277 7.318 7.277.527 0 1.04-.055 1.533-.16a.787.787 0 0 1 .81.316.733.733 0 0 1-.031.893A8.349 8.349 0 0 1 8.344 16C3.734 16 0 12.286 0 7.71 0 4.266 2.114 1.312 5.124.06A.752.752 0 0 1 6 .278z"/></svg>',n="{}",l="{}";e=e||{},this.element=t;var t=this.element.hasAttribute("allowsCookie")||e.allowsCookie||s,h=this.#getColorScheme(t);this.options={state:null===h?o:h,root:this.element.getAttribute("data-root")||e.root||i,allowsCookie:t,lightlabel:this.element.getAttribute("data-lightlabel")||e.lightlabel||r,darklabel:this.element.getAttribute("data-darklabel")||e.darklabel||a,lightvars:this.element.getAttribute("data-lightvars")||e.lightvars||n,darkvars:this.element.getAttribute("data-darkvars")||e.darkvars||l},this.#init()}#init(){this.#render(),this.element.addEventListener("touchstart",t=>{this.#actionPerformed(t,this)}),this.element.addEventListener("click",t=>{this.#actionPerformed(t,this)}),window.matchMedia&&window.matchMedia("(prefers-color-scheme: light)").addEventListener("change",t=>{this.options.state!=t.matches&&this.#actionPerformed(t,this)}),this.element._bsDarkmode=this}#render(){this.element.innerHTML=this.options.state?this.options.lightlabel:this.options.darklabel;var t=JSON.parse(this.options.state?this.options.lightvars:this.options.darkvars);if("object"!=typeof t||Array.isArray(t)||null===t)throw new DOMException("Vars must be in a JSON Object.","TypeMismatchError");const o=document.querySelector(this.options.root),i=(o.removeAttribute("style"),Object.entries(t).forEach(([t,e])=>{o.style.setProperty("--bs-"+t,e)}),["primary","secondary","success","info","warning","danger","light","dark","white","black","body-color","body-bg"]);let s,r;Object.entries(t).forEach(([t,e])=>{i.includes(t)&&(r=this.#hexToRGB(e),s=this.#hexToHSL(e),o.style.setProperty("--bs-"+t+"-h",s.h+""),o.style.setProperty("--bs-"+t+"-s",s.s+"%"),o.style.setProperty("--bs-"+t+"-l",s.l+"%"),o.style.setProperty("--bs-"+t+"-rgb",r.r+","+r.g+","+r.b))}),this.options.state?(o.classList.remove(this.DARKMODE_CLASS),o.classList.add(this.LIGHTMODE_CLASS)):(o.classList.add(this.DARKMODE_CLASS),o.classList.remove(this.LIGHTMODE_CLASS))}toggle=function(t=!1){this.options.state=!this.options.state,this.#render(),t||this.#trigger()};light=function(t=!1){this.options.state||(this.options.state=!0,this.#render(),t||this.#trigger())};dark=function(t=!1){this.options.state&&(this.options.state=!1,this.#render(),t||this.#trigger())};#trigger=function(t){t||this.element.dispatchEvent(new Event("change",{bubbles:!0}))};setCookieAutorization=function(t){this.options.allowsCookie=t};#getColorScheme(t){let e=null;return t&&null!=(t=this.#getCookie(this.COOKIE_NAME))&&("light"===t?e=!0:"dark"===t&&(e=!1)),null===(e=null===e&&window.matchMedia&&window.matchMedia("(prefers-color-scheme: dark)").matches?!1:e)&&("light"===this.element.getAttribute("data-state")?e=!0:"dark"===this.element.getAttribute("data-state")&&(e=!1)),e}#actionPerformed(t,e){e.toggle(!1),e.options.allowsCookie&&e.#setCookie(e.COOKIE_NAME,e.options.state?"light":"dark",.25),t.preventDefault()}#hexToHSL(t){var t=this.#hexToRGB(t),e=t.r,o=t.g,t=t.b;e/=255,o/=255,t/=255;let i=Math.min(e,o,t),s=Math.max(e,o,t),r=s-i,a=0,n,l=0;return a=0==r?0:s==e?(o-t)/r%6:s==o?(t-e)/r+2:(e-o)/r+4,(a=Math.round(60*a))<0&&(a+=360),l=(s+i)/2,n=+(100*(0==r?0:r/(1-Math.abs(2*l-1)))).toFixed(1),l=+(100*l).toFixed(1),{h:a,s:n,l:l}}#hexToRGB(t){let e=0,o=0,i=0;return 4==t.length?(e=parseInt("0x"+t[1]+t[1]),o=parseInt("0x"+t[2]+t[2]),i=parseInt("0x"+t[3]+t[3])):7==t.length&&(e=parseInt("0x"+t[1]+t[2]),o=parseInt("0x"+t[3]+t[4]),i=parseInt("0x"+t[5]+t[6])),{r:e,g:o,b:i}}#setCookie(t,e,o){let i="";if(o){let t=new Date;t.setTime(t.getTime()+24*o*60*60*1e3),i="; expires="+t.toUTCString()}document.cookie=t+"="+(e||"")+i+"; path=/"}#getCookie(e){if(0<document.cookie.length){var o=document.cookie.indexOf(e+"=");if(-1!=o){o=o+e.length+1;let t=document.cookie.indexOf(";",o);return-1==t&&(t=document.cookie.length),decodeURIComponent(document.cookie.substring(o,t))}}return null}#deleteCookie(t){document.cookie=t+"=; Path=/; Expires=Thu, 01 Jan 1970 00:00:00 UTC;"}}Element.prototype.bsDarkmode=function(t,e){let o=this._bsDarkmode||new i(this,t);if(t&&"string"==typeof t)switch(t.toLowerCase()){case"toggle":o.toggle(e);break;case"light":o.light(e);break;case"dark":o.dark(e);break;case"setCookieAutorization":o.setCookieAutorization(e);break;default:throw new DOMException("Bootstrap-Darkmode method '"+t+"' doesn't exist","NotSupportedError")}},"undefined"!=typeof window&&(window.onload=function(){document.querySelectorAll('[data-plugin="bsdarkmode"]').forEach(function(t){t.bsDarkmode()})}),"undefined"!=typeof module&&module.exports&&(module.exports=i)}();
//# sourceMappingURL=bs-darkmode.ecmas.min.js.map